## -*- coding: utf-8 -*-


## MeninGIT -- Web-based wrapper of git
## By: Romain SOUFFLET <rsoufflet@easter-eggs.com>
##
## Copyright (C) 2011 Easter-eggs
## http://wiki.infos-pratiques.org/wiki/MeninGIT
##
## This file is part of meninGIT.
##
## MeninGIT is free software; you can redistribute it and/or modify
## it under the terms of the GNU Affero General Public License as
## published by the Free Software Foundation, either version 3 of the
## License, or (at your option) any later version.
##
## MeninGIT is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Affero General Public License for more details.
##
## You should have received a copy of the GNU Affero General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.


<%!
import difflib
import os

from dulwich.repo import Blob
from meningit.lib.utils import to_unicode, to_printable_date

def modified_files(commit_blobs, parent_commit_blobs, callback):
    content = False
    for blob_commit in commit_blobs:
        for blob in parent_commit_blobs:
            if blob[0] == blob_commit[0] and blob[1].id != blob_commit[1].id:
                if not content:
                    content = True
                    yield content
                yield callback(blob_commit[1].data.split('\n'),
                                blob[1].data.split('\n'),
                                blob_commit[0])
    if not content:
        yield content
%>\


<%def name="changes_file()" filter="trim">
    % if len(modif_list) > 0:
<div class="add">
    <h3>Fichiers ajoutés</h3>
        % for file in modif_list:
            % if file[1] == "create":
    <ins>${file[0]}</ins>
            % endif
        % endfor
</div>
<div class="remove">
    <h3>Fichiers supprimés</h3>
        % for file in modif_list:
            % if file[1] == "delete":
    <del>${file[0]}</del>
            % endif
        % endfor
</div>
    % else:
<div class="add">
    <h3>Aucun fichiers n'a été ajoutés</h3>
</div>
<div class="remove">
    <h3>Aucun fichiers n'a été supprimés</h3>
</div>
    % endif
</%def>

<%def name="file_diff(from_file, to_file, file_name)" filter="trim">
<%
    code = ""
    for line in difflib.context_diff(from_file, to_file, fromfile=file_name, tofile=file_name):
        code += "%s\n" % (line)
    code = to_unicode(code)
%>
<h3><a href="#">${file_name}</a></h3>
<pre>
${code | n}
</pre>
</%def>

<%def name="view_commit()" filter="trim">
<div id="diff-body">
    <h2 title="${commit_sha1}">Vue du commit datant du ${to_printable_date(commit_date)}</h2>

    <div class="add-remove-files">
        ${changes_file()}
    </div>

    <div class="update">
<%
    generator = modified_files(commit_blobs, parent_commit_blobs, file_diff)
%>
    % if generator.next():
        <h3>Fichiers modifié</h3>

        <div id="accordion" class="file-diff">
        % for modif in generator:
            ${modif}
        % endfor
        </div>
    % else:
        <h3>Aucun fichier n'a été modifié</h3>
    % endif
    </div>
</div>
</%def>
