## -*- coding: utf-8 -*-


## MeninGIT -- Web-based wrapper of git
## By: Romain SOUFFLET <rsoufflet@easter-eggs.com>
##
## Copyright (C) 2011 Easter-eggs
## http://wiki.infos-pratiques.org/wiki/MeninGIT
##
## This file is part of meninGIT.
##
## MeninGIT is free software; you can redistribute it and/or modify
## it under the terms of the GNU Affero General Public License as
## published by the Free Software Foundation, either version 3 of the
## License, or (at your option) any later version.
##
## MeninGIT is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Affero General Public License for more details.
##
## You should have received a copy of the GNU Affero General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.


<%!
from urllib import urlencode
from meningit.lib.git import has_changed
%>\


<%inherit file="site.mako"/>


<%def name="header()" filter="trim">
    <div class="header">
        <h1>Choississez un dépôt</h1>
    </div>
</%def>

<%def name="menu()" filter="trim">
</%def>


% if repos:
    % for site in repos:
    <div class="site-list">
        <h2>${site}</h2>
        % for repo in repos[site]:
            % if repo != 'here':
                <%
                    url = "diff_from_index?%s" % urlencode({'site': site, 'repo-name': repo})
                %>\
                <a href="${url}" class="link${' changed' if has_changed(repos[site][repo]) else u''}">${repo}</a>
            % endif
        % endfor
    </div>
    % endfor
% else:
    <p>No repositories configured, verify repos.ini is readable or not empty</p>
% endif
